Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 9291)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 9292)
@@ -1155,4 +1407,382 @@
 
    END SUBROUTINE seaice_asm_inc
+
+   SUBROUTINE logchl_asm_inc( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE logchl_asm_inc  ***
+      !!          
+      !! ** Purpose : Apply the chlorophyll assimilation increments.
+      !!
+      !! ** Method  : Calculate increments to state variables using nitrogen
+      !!              balancing.
+      !!              Direct initialization or Incremental Analysis Updating.
+      !!
+      !! ** Action  : 
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(IN) :: kt   ! Current time step
+      !
+      INTEGER  :: jk              ! Loop counter
+      INTEGER  :: it              ! Index
+      REAL(wp) :: zincwgt         ! IAU weight for current time step
+      REAL(wp) :: zincper         ! IAU interval in seconds
+      !!----------------------------------------------------------------------
+
+      IF ( kt <= nit000 ) THEN
+
+         zincper = (nitiaufin_r - nitiaustr_r + 1) * rdt
+
+#if defined key_medusa && defined key_foam_medusa
+         CALL asm_logchl_bal_medusa( logchl_bkginc, zincper, mld_choice_bgc, &
+            &                        rn_maxchlinc, ln_logchlbal, ln_asmdin,  &
+            &                        pgrow_avg_bkg, ploss_avg_bkg,           &
+            &                        phyt_avg_bkg, mld_max_bkg,              &
+            &                        tracer_bkg, logchl_balinc )
+#elif defined key_hadocc
+         CALL asm_logchl_bal_hadocc( logchl_bkginc, zincper, mld_choice_bgc, &
+            &                        rn_maxchlinc, ln_logchlbal, ln_asmdin,  &
+            &                        pgrow_avg_bkg, ploss_avg_bkg,           &
+            &                        phyt_avg_bkg, mld_max_bkg,              &
+            &                        chl_bkg, cchl_p_bkg,                    &
+            &                        tracer_bkg, logchl_balinc )
+#else
+         CALL ctl_stop( 'Attempting to assimilate logchl, ', &
+            &           'but not defined a biogeochemical model' )
+#endif
+
+      ENDIF
+
+      IF ( ln_asmiau ) THEN
+
+         !--------------------------------------------------------------------
+         ! Incremental Analysis Updating
+         !--------------------------------------------------------------------
+
+         IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
+
+            it = kt - nit000 + 1
+            zincwgt = wgtiau(it)      ! IAU weight for the current time step
+            ! note this is not a tendency so should not be divided by rdt
+
+            IF(lwp) THEN
+               WRITE(numout,*) 
+               WRITE(numout,*) 'logchl_asm_inc : logchl IAU at time step = ', &
+                  &  kt,' with IAU weight = ', wgtiau(it)
+               WRITE(numout,*) '~~~~~~~~~~~~'
+            ENDIF
+
+            ! Update the biogeochemical variables
+            ! Add directly to trn and trb, rather than to tra, because tra gets
+            ! reset to zero at the start of trc_stp, called after this routine
+#if defined key_medusa && defined key_foam_medusa
+            DO jk = 1, jpkm1
+               trn(:,:,jk,jp_msa0:jp_msa1) = trn(:,:,jk,jp_msa0:jp_msa1) + &
+                  &                          logchl_balinc(:,:,jk,jp_msa0:jp_msa1) * zincwgt
+               trb(:,:,jk,jp_msa0:jp_msa1) = trb(:,:,jk,jp_msa0:jp_msa1) + &
+                  &                          logchl_balinc(:,:,jk,jp_msa0:jp_msa1) * zincwgt
+            END DO
+#elif defined key_hadocc
+            DO jk = 1, jpkm1
+               trn(:,:,jk,jp_had0:jp_had1) = trn(:,:,jk,jp_had0:jp_had1) + &
+                  &                          logchl_balinc(:,:,jk,jp_had0:jp_had1) * zincwgt
+               trb(:,:,jk,jp_had0:jp_had1) = trb(:,:,jk,jp_had0:jp_had1) + &
+                  &                          logchl_balinc(:,:,jk,jp_had0:jp_had1) * zincwgt
+            END DO
+#endif
+
+            ! Do not deallocate arrays - needed by asm_bal_wri
+            ! which is called at end of model run
+         ENDIF
+
+      ELSEIF ( ln_asmdin ) THEN 
+
+         !--------------------------------------------------------------------
+         ! Direct Initialization
+         !--------------------------------------------------------------------
+         
+         IF ( kt == nitdin_r ) THEN
+
+            neuler = 0                    ! Force Euler forward step
+
+#if defined key_medusa && defined key_foam_medusa
+            ! Initialize the now fields with the background + increment
+            ! Background currently is what the model is initialised with
+            CALL ctl_warn( ' Doing direct initialisation of MEDUSA with chlorophyll assimilation', &
+               &           ' Background state is taken from model rather than background file' )
+            trn(:,:,:,jp_msa0:jp_msa1) = trn(:,:,:,jp_msa0:jp_msa1) + &
+               &                         logchl_balinc(:,:,:,jp_msa0:jp_msa1)
+            trb(:,:,:,jp_msa0:jp_msa1) = trn(:,:,:,jp_msa0:jp_msa1)
+#elif defined key_hadocc
+            ! Initialize the now fields with the background + increment
+            ! Background currently is what the model is initialised with
+            CALL ctl_warn( ' Doing direct initialisation of HadOCC with chlorophyll assimilation', &
+               &           ' Background state is taken from model rather than background file' )
+            trn(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1) + &
+               &                         logchl_balinc(:,:,:,jp_had0:jp_had1)
+            trb(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1)
+#endif
+ 
+            ! Do not deallocate arrays - needed by asm_bal_wri
+            ! which is called at end of model run
+         ENDIF
+         !
+      ENDIF
+      !
+   END SUBROUTINE logchl_asm_inc
+
+
+   SUBROUTINE pco2_asm_inc( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE pco2_asm_inc  ***
+      !!          
+      !! ** Purpose : Apply the pco2/fco2 assimilation increments.
+      !!
+      !! ** Method  : Calculate increments to state variables using carbon
+      !!              balancing.
+      !!              Direct initialization or Incremental Analysis Updating.
+      !!
+      !! ** Action  : 
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(IN)                   :: kt           ! Current time step
+      !
+      INTEGER                               :: ji, jj, jk   ! Loop counters
+      INTEGER                               :: it           ! Index
+      INTEGER                               :: jkmax        ! Index of mixed layer depth
+      REAL(wp)                              :: zincwgt      ! IAU weight for current time step
+      REAL(wp), DIMENSION(jpi,jpj)          :: zmld         ! Mixed layer depth for balancing
+      REAL(wp), DIMENSION(jpi,jpj)          :: pco2_bkginc_temp ! For fCO2 conversion
+      REAL(wp), DIMENSION(jpi,jpj)          :: dic_bkg_temp ! DIC background
+      REAL(wp), DIMENSION(jpi,jpj)          :: alk_bkg_temp ! Alkalinity background
+      REAL(wp), DIMENSION(jpi,jpj)          :: tem_bkg_temp ! Temperature background
+      REAL(wp), DIMENSION(jpi,jpj)          :: sal_bkg_temp ! Salinity background
+      REAL(wp), DIMENSION(1)                :: patm         ! Atmospheric pressure
+      REAL(wp), DIMENSION(1)                :: phyd         ! Hydrostatic pressure
+
+      ! Coefficients for fCO2 to pCO2 conversion
+      REAL(wp)                              :: zcoef_fco2_1 = -1636.75
+      REAL(wp)                              :: zcoef_fco2_2 = 12.0408
+      REAL(wp)                              :: zcoef_fco2_3 = 0.0327957
+      REAL(wp)                              :: zcoef_fco2_4 = 0.0000316528
+      REAL(wp)                              :: zcoef_fco2_5 = 2.0
+      REAL(wp)                              :: zcoef_fco2_6 = 57.7
+      REAL(wp)                              :: zcoef_fco2_7 = 0.118
+      REAL(wp)                              :: zcoef_fco2_8 = 82.0578
+      !!----------------------------------------------------------------------
+
+      IF ( kt <= nit000 ) THEN
+
+         !--------------------------------------------------------------------
+         ! DIC and alkalinity balancing
+         !--------------------------------------------------------------------
+
+         IF ( ln_fco2inc ) THEN
+#if defined key_medusa && defined key_roam
+            ! If assimilating fCO2, then convert to pCO2 using MEDUSA MOCSY subroutine
+            patm(1) = 1.0
+            phyd(1) = 0.0
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  CALL f2pCO2( pco2_bkginc(ji,jj), tsn(ji,jj,1,1), patm, phyd, 1, pco2_bkginc_temp(ji,jj) )
+               END DO
+            END DO
+#else
+            ! If assimilating fCO2, then convert to pCO2 using temperature
+            ! See flux_gas.F90 within HadOCC for details of calculation
+            pco2_bkginc_temp(:,:) = pco2_bkginc(:,:) /                                                             &
+               &                    EXP((zcoef_fco2_1                                                            + &
+               &                         zcoef_fco2_2 * (tsn(:,:,1,1)+rt0)                                       - &
+               &                         zcoef_fco2_3 * (tsn(:,:,1,1)+rt0)*(tsn(:,:,1,1)+rt0)                    + &
+               &                         zcoef_fco2_4 * (tsn(:,:,1,1)+rt0)*(tsn(:,:,1,1)+rt0)*(tsn(:,:,1,1)+rt0) + &
+               &                         zcoef_fco2_5 * (zcoef_fco2_6 - zcoef_fco2_7 * (tsn(:,:,1,1)+rt0)))      / &
+               &                        (zcoef_fco2_8 * (tsn(:,:,1,1)+rt0)))
+#endif
+         ELSE
+            pco2_bkginc_temp(:,:) = pco2_bkginc(:,:)
+         ENDIF
+
+         ! Account for physics assimilation if required
+         IF ( ln_trainc ) THEN
+            tem_bkg_temp(:,:) = tsn(:,:,1,1) + t_bkginc(:,:,1)
+            sal_bkg_temp(:,:) = tsn(:,:,1,2) + s_bkginc(:,:,1)
+         ELSE
+            tem_bkg_temp(:,:) = tsn(:,:,1,1)
+            sal_bkg_temp(:,:) = tsn(:,:,1,2)
+         ENDIF
+
+#if defined key_medusa
+         ! Account for logchl balancing if required
+         IF ( ln_logchlinc .AND. ln_logchlbal ) THEN
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jpdic) + logchl_balinc(:,:,1,jpdic)
+            alk_bkg_temp(:,:) = tracer_bkg(:,:,1,jpalk) + logchl_balinc(:,:,1,jpalk)
+         ELSE
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jpdic)
+            alk_bkg_temp(:,:) = tracer_bkg(:,:,1,jpalk)
+         ENDIF
+
+         CALL asm_pco2_bal( pco2_bkginc_temp(:,:), dic_bkg_temp(:,:), alk_bkg_temp(:,:), &
+            &               tem_bkg_temp(:,:), sal_bkg_temp(:,:),                        &
+            &               pco2_balinc(:,:,1,jpdic), pco2_balinc(:,:,1,jpalk) )
+
+#elif defined key_hadocc
+         ! Account for logchl balancing if required
+         IF ( ln_logchlinc .AND. ln_logchlbal ) THEN
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_had_dic) + logchl_balinc(:,:,1,jp_had_dic)
+            alk_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_had_alk) + logchl_balinc(:,:,1,jp_had_alk)
+         ELSE
+            dic_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_had_dic)
+            alk_bkg_temp(:,:) = tracer_bkg(:,:,1,jp_had_alk)
+         ENDIF
+
+         CALL asm_pco2_bal( pco2_bkginc_temp(:,:), dic_bkg_temp(:,:), alk_bkg_temp(:,:), &
+            &               tem_bkg_temp(:,:), sal_bkg_temp(:,:),                        &
+            &               pco2_balinc(:,:,1,jp_had_dic), pco2_balinc(:,:,1,jp_had_alk) )
+
+#else
+         CALL ctl_stop( 'Attempting to assimilate pCO2/fCO2, ', &
+            &           'but not defined a biogeochemical model' )
+#endif
+
+         ! Select mixed layer
+         IF ( ln_asmdin ) THEN
+#if defined key_hadocc || (defined key_medusa && defined key_foam_medusa)
+            CALL ctl_warn( ' Doing direct initialisation with pCO2 assimilation', &
+               &           ' Mixed layer depth taken to be background maximum mld_max_bkg' )
+            zmld(:,:) = mld_max_bkg(:,:)
+#else
+            CALL ctl_stop( 'No biogeochemical model defined for pCO2 assimilation' )
+#endif
+         ELSE
+            SELECT CASE( mld_choice_bgc )
+            CASE ( 1 )                   ! Turbocline/mixing depth [W points]
+               zmld(:,:) = hmld(:,:)
+            CASE ( 2 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [W points]
+               zmld(:,:) = hmlp(:,:)
+            CASE ( 3 )                   ! Kara MLD [Interpolated]
+#if defined key_karaml
+               IF ( ln_kara ) THEN
+                  zmld(:,:) = hmld_kara(:,:)
+               ELSE
+                  CALL ctl_stop( ' Kara mixed layer requested for pCO2 assimilation,', &
+                     &           ' but ln_kara=.false.' )
+               ENDIF
+#else
+               CALL ctl_stop( ' Kara mixed layer requested for pCO2 assimilation,', &
+                  &           ' but is not defined' )
+#endif
+            CASE ( 4 )                   ! Temperature criterion (0.2 K change from surface) [T points]
+               !zmld(:,:) = hmld_tref(:,:)
+               CALL ctl_stop( ' hmld_tref mixed layer requested for pCO2 assimilation,', &
+                  &           ' but is not available in this version' )
+            CASE ( 5 )                   ! Density criterion (0.01 kg/m^3 change from 10m) [T points]
+               zmld(:,:) = hmlpt(:,:)
+            END SELECT
+         ENDIF
+
+         ! Propagate through mixed layer
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               !
+               jkmax = jpk-1
+               DO jk = jpk-1, 1, -1
+                  IF ( ( zmld(ji,jj) >  gdepw_n(ji,jj,jk)   ) .AND. &
+                     & ( zmld(ji,jj) <= gdepw_n(ji,jj,jk+1) ) ) THEN
+                     zmld(ji,jj) = gdepw_n(ji,jj,jk+1)
+                     jkmax = jk
+                  ENDIF
+               END DO
+               !
+#if defined key_top
+               DO jk = 2, jkmax
+                  pco2_balinc(ji,jj,jk,:) = pco2_balinc(ji,jj,1,:)
+               END DO
+#endif
+               !
+            END DO
+         END DO
+
+      ENDIF
+
+      IF ( ln_asmiau ) THEN
+
+         !--------------------------------------------------------------------
+         ! Incremental Analysis Updating
+         !--------------------------------------------------------------------
+
+         IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
+
+            it = kt - nit000 + 1
+            zincwgt = wgtiau(it)      ! IAU weight for the current time step
+            ! note this is not a tendency so should not be divided by rdt
+
+            IF(lwp) THEN
+               WRITE(numout,*) 
+               IF ( ln_pco2inc ) THEN
+                  WRITE(numout,*) 'pco2_asm_inc : pco2 IAU at time step = ', &
+                     &  kt,' with IAU weight = ', wgtiau(it)
+               ELSE IF ( ln_fco2inc ) THEN
+                  WRITE(numout,*) 'fco2_asm_inc : fco2 IAU at time step = ', &
+                     &  kt,' with IAU weight = ', wgtiau(it)
+               ENDIF
+               WRITE(numout,*) '~~~~~~~~~~~~'
+            ENDIF
+
+            ! Update the biogeochemical variables
+            ! Add directly to trn and trb, rather than to tra, because tra gets
+            ! reset to zero at the start of trc_stp, called after this routine
+#if defined key_medusa && defined key_foam_medusa
+            DO jk = 1, jpkm1
+               trn(:,:,jk,jp_msa0:jp_msa1) = trn(:,:,jk,jp_msa0:jp_msa1) + &
+                  &                          pco2_balinc(:,:,jk,jp_msa0:jp_msa1) * zincwgt
+               trb(:,:,jk,jp_msa0:jp_msa1) = trb(:,:,jk,jp_msa0:jp_msa1) + &
+                  &                          pco2_balinc(:,:,jk,jp_msa0:jp_msa1) * zincwgt
+            END DO
+#elif defined key_hadocc
+            DO jk = 1, jpkm1
+               trn(:,:,jk,jp_had0:jp_had1) = trn(:,:,jk,jp_had0:jp_had1) + &
+                  &                          pco2_balinc(:,:,jk,jp_had0:jp_had1) * zincwgt
+               trb(:,:,jk,jp_had0:jp_had1) = trb(:,:,jk,jp_had0:jp_had1) + &
+                  &                          pco2_balinc(:,:,jk,jp_had0:jp_had1) * zincwgt
+            END DO
+#endif
+
+            ! Do not deallocate arrays - needed by asm_bal_wri
+            ! which is called at end of model run
+
+         ENDIF
+
+      ELSEIF ( ln_asmdin ) THEN 
+
+         !--------------------------------------------------------------------
+         ! Direct Initialization
+         !--------------------------------------------------------------------
+         
+         IF ( kt == nitdin_r ) THEN
+
+            neuler = 0                    ! Force Euler forward step
+
+#if defined key_medusa && defined key_foam_medusa
+            ! Initialize the now fields with the background + increment
+            ! Background currently is what the model is initialised with
+            CALL ctl_warn( ' Doing direct initialisation of MEDUSA with pCO2 assimilation', &
+               &           ' Background state is taken from model rather than background file' )
+            trn(:,:,:,jp_msa0:jp_msa1) = trn(:,:,:,jp_msa0:jp_msa1) + &
+               &                         pco2_balinc(:,:,:,jp_msa0:jp_msa1)
+            trb(:,:,:,jp_msa0:jp_msa1) = trn(:,:,:,jp_msa0:jp_msa1)
+#elif defined key_hadocc
+            ! Initialize the now fields with the background + increment
+            ! Background currently is what the model is initialised with
+            CALL ctl_warn( ' Doing direct initialisation of HadOCC with pCO2 assimilation', &
+               &           ' Background state is taken from model rather than background file' )
+            trn(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1) + &
+               &                         pco2_balinc(:,:,:,jp_had0:jp_had1)
+            trb(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1)
+#endif
+ 
+            ! Do not deallocate arrays - needed by asm_bal_wri
+            ! which is called at end of model run
+         ENDIF
+         !
+      ENDIF
+      !
+   END SUBROUTINE pco2_asm_inc
    
    !!======================================================================
